unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs, unit2;

type
  TPaoService = class(TService)
    procedure ServiceExecute(Sender: TService);
    procedure ServiceStart(Sender: TService; var Started: Boolean);
    procedure ServiceStop(Sender: TService; var Stopped: Boolean);
    procedure ServicePause(Sender: TService; var Paused: Boolean);
    procedure ServiceContinue(Sender: TService; var Continued: Boolean);
    procedure ServiceShutdown(Sender: TService);
  private
    { Private declarations }
  public
    function GetServiceController: TServiceController; override;
    { Public declarations }
  end;

var
  PaoService: TPaoService;
  PaoSvcForm: TPaoServForm;

implementation

{$R *.DFM}

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  PaoService.Controller(CtrlCode);
end;

function TPaoService.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

procedure TPaoService.ServiceExecute(Sender: TService);
begin
  while not Terminated do
  begin
    Sleep(10);
    ServiceThread.ProcessRequests(false);
  end;
end;

procedure TPaoService.ServiceStart(Sender: TService; var Started: Boolean);
begin
  Started := true;
  Svcmgr.Application.CreateForm(TPaoServForm, PaoSvcForm);
  gbCanClose := false;
  PaoSvcForm.Hide;
end;

procedure TPaoService.ServiceStop(Sender: TService; var Stopped: Boolean);
begin
  Stopped := true;
  gbCanClose := true;
  PaoSvcForm.Free;
end;

procedure TPaoService.ServicePause(Sender: TService; var Paused: Boolean);
begin
  Paused := true;
end;

procedure TPaoService.ServiceContinue(Sender: TService;
  var Continued: Boolean);
begin
  Continued := true;
end;

procedure TPaoService.ServiceShutdown(Sender: TService);
begin
  gbCanClose := true;
  PaoSvcForm.Free;
  Status := csStopped;
  ReportStatus();
end;

end.
